"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceCPU = void 0;
var device_1 = require("./device");
var storage_1 = require("./storage");
var kernel_cpu_1 = require("./kernel_cpu");
var DeviceCPU = /** @class */ (function (_super) {
    __extends(DeviceCPU, _super);
    function DeviceCPU() {
        return _super.call(this, "cpu", "cpu") || this;
    }
    DeviceCPU.prototype.alloc = function (byteSize) {
        return new storage_1.ArrayBufferStorage(byteSize);
    };
    DeviceCPU.prototype.createKernel = function (spec, config) {
        return new kernel_cpu_1.KernelCPU(spec, config, this);
    };
    DeviceCPU.prototype.getStorageFromKernel = function (storage) {
        if (storage instanceof Uint8Array ||
            storage instanceof Uint32Array ||
            storage instanceof Int32Array ||
            storage instanceof Float32Array) {
            return new storage_1.ArrayBufferStorage(storage.buffer);
        }
        throw new Error("Cannot wrap buffer of type ".concat(storage.constructor.name, " to get CPU storage"));
    };
    DeviceCPU.prototype.getBufferForKernel = function (storage, dtype) {
        if (storage instanceof storage_1.ArrayBufferStorage) {
            return storage.getTypedArray(dtype);
        }
        throw new Error("Cannot unwrap buffer of type ".concat(storage.constructor.name, " to get CPU buffer"));
    };
    return DeviceCPU;
}(device_1.Device));
exports.DeviceCPU = DeviceCPU;
//# sourceMappingURL=device_cpu.js.map