"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceWebGPU = void 0;
var device_1 = require("./device");
var storage_1 = require("./storage");
var kernel_webgpu_1 = require("./kernel_webgpu");
var DeviceWebGPU = /** @class */ (function (_super) {
    __extends(DeviceWebGPU, _super);
    function DeviceWebGPU(id, adapter, device) {
        var _this = _super.call(this, id, "webgpu") || this;
        _this._device = device;
        return _this;
    }
    Object.defineProperty(DeviceWebGPU.prototype, "gpuDevice", {
        get: function () {
            return this._device;
        },
        enumerable: false,
        configurable: true
    });
    DeviceWebGPU.prototype.alloc = function (byteSize) {
        return new storage_1.GPUBufferStorage(byteSize, this._device, GPUBufferUsage.STORAGE | GPUBufferUsage.COPY_SRC);
    };
    DeviceWebGPU.prototype.createKernel = function (spec, config) {
        return new kernel_webgpu_1.KernelWebGPU(spec, config, this);
    };
    DeviceWebGPU.prototype.getStorageFromKernel = function (storage) {
        if (storage instanceof GPUBuffer) {
            return new storage_1.GPUBufferStorage(storage, this.gpuDevice);
        }
        throw new Error("Cannot wrap buffer of type ".concat(storage.constructor.name, " to get GPU storage"));
    };
    DeviceWebGPU.prototype.getBufferForKernel = function (storage, dtype) {
        if (storage instanceof storage_1.GPUBufferStorage) {
            return storage.gpuBuffer;
        }
        throw new Error("Cannot unwrap storage of type ".concat(storage.constructor.name, " to get GPU buffer"));
    };
    return DeviceWebGPU;
}(device_1.Device));
exports.DeviceWebGPU = DeviceWebGPU;
//# sourceMappingURL=device_webgpu.js.map