"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDtype = exports.dtypeByteSize = exports.dtypeArrayCtors = void 0;
exports.dtypeArrayCtors = {
    "uint8": Uint8Array,
    "int32": Int32Array,
    "uint32": Uint32Array,
    "float32": Float32Array,
};
function dtypeByteSize(dtype) {
    switch (dtype) {
        case "uint8":
            return 1;
        case "int32":
            return 4;
        case "uint32":
            return 4;
        case "float32":
            return 4;
        default:
            throw new Error("Invalid dtype ".concat(dtype));
    }
}
exports.dtypeByteSize = dtypeByteSize;
function getDtype(dtype, defaultType) {
    if (dtype === null || dtype === undefined) {
        return defaultType || "float32";
    }
    else if (dtype === "uint8") {
        return "uint8";
    }
    else if (dtype === "int32") {
        return "int32";
    }
    else if (dtype === "uint32") {
        return "uint32";
    }
    else if (dtype === "float32") {
        return "float32";
    }
    else if (dtype instanceof Uint8Array) {
        return "uint8";
    }
    else if (dtype instanceof Int32Array) {
        return "int32";
    }
    else if (dtype instanceof Uint32Array) {
        return "uint32";
    }
    else if (dtype instanceof Float32Array) {
        return "float32";
    }
    else {
        throw new Error("Invalid dtype ".concat(JSON.stringify(dtype)));
    }
}
exports.getDtype = getDtype;
//# sourceMappingURL=dtype.js.map