"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zeros = exports.ones = void 0;
var shape_1 = require("./shape");
var devices_1 = require("./devices");
var dtype_1 = require("./dtype");
var tensor_1 = require("./tensor");
function ones(shape, dtype, device) {
    var d = (0, devices_1.getDevice)(device);
    var s = (0, shape_1.getShape)(shape);
    var dt = (0, dtype_1.getDtype)(dtype);
    var storage = d.allocFor(s, dt);
    var array = storage.getTypedArray(dt);
    array.fill(1);
    return new tensor_1.Tensor({
        data: storage,
        dtype: dt,
        shape: s,
        strides: (0, shape_1.defaultStrides)(s),
        device: d,
    });
}
exports.ones = ones;
function zeros(shape, dtype, device) {
    var d = (0, devices_1.getDevice)(device);
    var s = (0, shape_1.getShape)(shape);
    var dt = (0, dtype_1.getDtype)(dtype);
    var storage = d.allocFor(s, dt);
    var array = storage.getTypedArray(dt);
    array.fill(1);
    return new tensor_1.Tensor({
        data: storage,
        dtype: dt,
        shape: s,
        strides: (0, shape_1.defaultStrides)(s),
        device: d,
    });
}
exports.zeros = zeros;
//# sourceMappingURL=factories.js.map