"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AllFunction = exports.XlogyFunction = exports.TruncFunction = exports.TanhFunction = exports.TanFunction = exports.SubFunction = exports.SquareFunction = exports.SqrtFunction = exports.SinhFunction = exports.SincFunction = exports.SinFunction = exports.SiluFunction = exports.SignFunction = exports.SigmoidFunction = exports.RsqrtFunction = exports.RoundFunction = exports.ReluFunction = exports.ReciprocalFunction = exports.Rad2degFunction = exports.PowFunction = exports.PositiveFunction = exports.NegFunction = exports.MulFunction = exports.Logaddexp2Function = exports.LogaddexpFunction = exports.Log2Function = exports.Log1pFunction = exports.Log10Function = exports.LogFunction = exports.LdexpFunction = exports.HypotFunction = exports.FracFunction = exports.FloorFunction = exports.Expm1Function = exports.Exp2Function = exports.ExpFunction = exports.DivFunction = exports.Deg2radFunction = exports.CoshFunction = exports.CosFunction = exports.CopysignFunction = exports.CeilFunction = exports.Atan2Function = exports.AtanFunction = exports.AsinhFunction = exports.AsinFunction = exports.AddFunction = exports.AcoshFunction = exports.AcosFunction = exports.AbsFunction = void 0;
exports.CountNonzeroFunction = exports.SumFunction = exports.ProdFunction = exports.NormFunction = exports.MeanFunction = exports.AnyFunction = void 0;
var autograd_1 = require("./autograd");
var shape_1 = require("./shape");
var AbsFunction = /** @class */ (function (_super) {
    __extends(AbsFunction, _super);
    function AbsFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AbsFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("abs", { "dtype": "float32" }, params, [input.shape])[0];
    };
    AbsFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AbsFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("absGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return AbsFunction;
}(autograd_1.AutoFunction));
exports.AbsFunction = AbsFunction;
var AcosFunction = /** @class */ (function (_super) {
    __extends(AcosFunction, _super);
    function AcosFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AcosFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("acos", { "dtype": "float32" }, params, [input.shape])[0];
    };
    AcosFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AcosFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("acosGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return AcosFunction;
}(autograd_1.AutoFunction));
exports.AcosFunction = AcosFunction;
var AcoshFunction = /** @class */ (function (_super) {
    __extends(AcoshFunction, _super);
    function AcoshFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AcoshFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("acosh", { "dtype": "float32" }, params, [input.shape])[0];
    };
    AcoshFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AcoshFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("acoshGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return AcoshFunction;
}(autograd_1.AutoFunction));
exports.AcoshFunction = AcoshFunction;
var AddFunction = /** @class */ (function (_super) {
    __extends(AddFunction, _super);
    function AddFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AddFunction.forward = function (inputs) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: alpha || 1.0,
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("add", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    AddFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        ctx.alpha = alpha;
        ctx.saveForBackward(input, other);
    };
    AddFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: ctx.alpha || 1.0,
        };
        return input.runKernel("addGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return AddFunction;
}(autograd_1.AutoFunction));
exports.AddFunction = AddFunction;
var AsinFunction = /** @class */ (function (_super) {
    __extends(AsinFunction, _super);
    function AsinFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AsinFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("asin", { "dtype": "float32" }, params, [input.shape])[0];
    };
    AsinFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AsinFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("asinGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return AsinFunction;
}(autograd_1.AutoFunction));
exports.AsinFunction = AsinFunction;
var AsinhFunction = /** @class */ (function (_super) {
    __extends(AsinhFunction, _super);
    function AsinhFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AsinhFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("asinh", { "dtype": "float32" }, params, [input.shape])[0];
    };
    AsinhFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AsinhFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("asinhGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return AsinhFunction;
}(autograd_1.AutoFunction));
exports.AsinhFunction = AsinhFunction;
var AtanFunction = /** @class */ (function (_super) {
    __extends(AtanFunction, _super);
    function AtanFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AtanFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("atan", { "dtype": "float32" }, params, [input.shape])[0];
    };
    AtanFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AtanFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("atanGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return AtanFunction;
}(autograd_1.AutoFunction));
exports.AtanFunction = AtanFunction;
var Atan2Function = /** @class */ (function (_super) {
    __extends(Atan2Function, _super);
    function Atan2Function() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Atan2Function.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("atan2", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    Atan2Function.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    Atan2Function.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("atan2Grad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return Atan2Function;
}(autograd_1.AutoFunction));
exports.Atan2Function = Atan2Function;
var CeilFunction = /** @class */ (function (_super) {
    __extends(CeilFunction, _super);
    function CeilFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CeilFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("ceil", { "dtype": "float32" }, params, [input.shape])[0];
    };
    CeilFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    CeilFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("ceilGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return CeilFunction;
}(autograd_1.AutoFunction));
exports.CeilFunction = CeilFunction;
var CopysignFunction = /** @class */ (function (_super) {
    __extends(CopysignFunction, _super);
    function CopysignFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CopysignFunction.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("copysign", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    CopysignFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    CopysignFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("copysignGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return CopysignFunction;
}(autograd_1.AutoFunction));
exports.CopysignFunction = CopysignFunction;
var CosFunction = /** @class */ (function (_super) {
    __extends(CosFunction, _super);
    function CosFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CosFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("cos", { "dtype": "float32" }, params, [input.shape])[0];
    };
    CosFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    CosFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("cosGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return CosFunction;
}(autograd_1.AutoFunction));
exports.CosFunction = CosFunction;
var CoshFunction = /** @class */ (function (_super) {
    __extends(CoshFunction, _super);
    function CoshFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CoshFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("cosh", { "dtype": "float32" }, params, [input.shape])[0];
    };
    CoshFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    CoshFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("coshGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return CoshFunction;
}(autograd_1.AutoFunction));
exports.CoshFunction = CoshFunction;
var Deg2radFunction = /** @class */ (function (_super) {
    __extends(Deg2radFunction, _super);
    function Deg2radFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Deg2radFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("deg2rad", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Deg2radFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Deg2radFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("deg2radGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Deg2radFunction;
}(autograd_1.AutoFunction));
exports.Deg2radFunction = Deg2radFunction;
var DivFunction = /** @class */ (function (_super) {
    __extends(DivFunction, _super);
    function DivFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DivFunction.forward = function (inputs) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: alpha || 1.0,
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("div", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    DivFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        ctx.alpha = alpha;
        ctx.saveForBackward(input, other);
    };
    DivFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: ctx.alpha || 1.0,
        };
        return input.runKernel("divGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return DivFunction;
}(autograd_1.AutoFunction));
exports.DivFunction = DivFunction;
var ExpFunction = /** @class */ (function (_super) {
    __extends(ExpFunction, _super);
    function ExpFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ExpFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("exp", { "dtype": "float32" }, params, [input.shape])[0];
    };
    ExpFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    ExpFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("expGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return ExpFunction;
}(autograd_1.AutoFunction));
exports.ExpFunction = ExpFunction;
var Exp2Function = /** @class */ (function (_super) {
    __extends(Exp2Function, _super);
    function Exp2Function() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Exp2Function.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("exp2", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Exp2Function.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Exp2Function.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("exp2Grad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Exp2Function;
}(autograd_1.AutoFunction));
exports.Exp2Function = Exp2Function;
var Expm1Function = /** @class */ (function (_super) {
    __extends(Expm1Function, _super);
    function Expm1Function() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Expm1Function.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("expm1", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Expm1Function.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Expm1Function.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("expm1Grad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Expm1Function;
}(autograd_1.AutoFunction));
exports.Expm1Function = Expm1Function;
var FloorFunction = /** @class */ (function (_super) {
    __extends(FloorFunction, _super);
    function FloorFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FloorFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("floor", { "dtype": "float32" }, params, [input.shape])[0];
    };
    FloorFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    FloorFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("floorGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return FloorFunction;
}(autograd_1.AutoFunction));
exports.FloorFunction = FloorFunction;
var FracFunction = /** @class */ (function (_super) {
    __extends(FracFunction, _super);
    function FracFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FracFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("frac", { "dtype": "float32" }, params, [input.shape])[0];
    };
    FracFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    FracFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("fracGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return FracFunction;
}(autograd_1.AutoFunction));
exports.FracFunction = FracFunction;
var HypotFunction = /** @class */ (function (_super) {
    __extends(HypotFunction, _super);
    function HypotFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HypotFunction.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("hypot", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    HypotFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    HypotFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("hypotGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return HypotFunction;
}(autograd_1.AutoFunction));
exports.HypotFunction = HypotFunction;
var LdexpFunction = /** @class */ (function (_super) {
    __extends(LdexpFunction, _super);
    function LdexpFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LdexpFunction.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("ldexp", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    LdexpFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    LdexpFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("ldexpGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return LdexpFunction;
}(autograd_1.AutoFunction));
exports.LdexpFunction = LdexpFunction;
var LogFunction = /** @class */ (function (_super) {
    __extends(LogFunction, _super);
    function LogFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("log", { "dtype": "float32" }, params, [input.shape])[0];
    };
    LogFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    LogFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("logGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return LogFunction;
}(autograd_1.AutoFunction));
exports.LogFunction = LogFunction;
var Log10Function = /** @class */ (function (_super) {
    __extends(Log10Function, _super);
    function Log10Function() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Log10Function.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("log10", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Log10Function.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Log10Function.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("log10Grad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Log10Function;
}(autograd_1.AutoFunction));
exports.Log10Function = Log10Function;
var Log1pFunction = /** @class */ (function (_super) {
    __extends(Log1pFunction, _super);
    function Log1pFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Log1pFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("log1p", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Log1pFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Log1pFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("log1pGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Log1pFunction;
}(autograd_1.AutoFunction));
exports.Log1pFunction = Log1pFunction;
var Log2Function = /** @class */ (function (_super) {
    __extends(Log2Function, _super);
    function Log2Function() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Log2Function.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("log2", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Log2Function.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Log2Function.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("log2Grad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Log2Function;
}(autograd_1.AutoFunction));
exports.Log2Function = Log2Function;
var LogaddexpFunction = /** @class */ (function (_super) {
    __extends(LogaddexpFunction, _super);
    function LogaddexpFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LogaddexpFunction.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("logaddexp", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    LogaddexpFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    LogaddexpFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("logaddexpGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return LogaddexpFunction;
}(autograd_1.AutoFunction));
exports.LogaddexpFunction = LogaddexpFunction;
var Logaddexp2Function = /** @class */ (function (_super) {
    __extends(Logaddexp2Function, _super);
    function Logaddexp2Function() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Logaddexp2Function.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("logaddexp2", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    Logaddexp2Function.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    Logaddexp2Function.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("logaddexp2Grad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return Logaddexp2Function;
}(autograd_1.AutoFunction));
exports.Logaddexp2Function = Logaddexp2Function;
var MulFunction = /** @class */ (function (_super) {
    __extends(MulFunction, _super);
    function MulFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MulFunction.forward = function (inputs) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: alpha || 1.0,
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("mul", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    MulFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        ctx.alpha = alpha;
        ctx.saveForBackward(input, other);
    };
    MulFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: ctx.alpha || 1.0,
        };
        return input.runKernel("mulGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return MulFunction;
}(autograd_1.AutoFunction));
exports.MulFunction = MulFunction;
var NegFunction = /** @class */ (function (_super) {
    __extends(NegFunction, _super);
    function NegFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NegFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("neg", { "dtype": "float32" }, params, [input.shape])[0];
    };
    NegFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    NegFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("negGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return NegFunction;
}(autograd_1.AutoFunction));
exports.NegFunction = NegFunction;
var PositiveFunction = /** @class */ (function (_super) {
    __extends(PositiveFunction, _super);
    function PositiveFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PositiveFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("positive", { "dtype": "float32" }, params, [input.shape])[0];
    };
    PositiveFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    PositiveFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("positiveGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return PositiveFunction;
}(autograd_1.AutoFunction));
exports.PositiveFunction = PositiveFunction;
var PowFunction = /** @class */ (function (_super) {
    __extends(PowFunction, _super);
    function PowFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PowFunction.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("pow", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    PowFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    PowFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("powGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return PowFunction;
}(autograd_1.AutoFunction));
exports.PowFunction = PowFunction;
var Rad2degFunction = /** @class */ (function (_super) {
    __extends(Rad2degFunction, _super);
    function Rad2degFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rad2degFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("rad2deg", { "dtype": "float32" }, params, [input.shape])[0];
    };
    Rad2degFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    Rad2degFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("rad2degGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return Rad2degFunction;
}(autograd_1.AutoFunction));
exports.Rad2degFunction = Rad2degFunction;
var ReciprocalFunction = /** @class */ (function (_super) {
    __extends(ReciprocalFunction, _super);
    function ReciprocalFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReciprocalFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("reciprocal", { "dtype": "float32" }, params, [input.shape])[0];
    };
    ReciprocalFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    ReciprocalFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("reciprocalGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return ReciprocalFunction;
}(autograd_1.AutoFunction));
exports.ReciprocalFunction = ReciprocalFunction;
var ReluFunction = /** @class */ (function (_super) {
    __extends(ReluFunction, _super);
    function ReluFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReluFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("relu", { "dtype": "float32" }, params, [input.shape])[0];
    };
    ReluFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    ReluFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("reluGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return ReluFunction;
}(autograd_1.AutoFunction));
exports.ReluFunction = ReluFunction;
var RoundFunction = /** @class */ (function (_super) {
    __extends(RoundFunction, _super);
    function RoundFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RoundFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("round", { "dtype": "float32" }, params, [input.shape])[0];
    };
    RoundFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    RoundFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("roundGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return RoundFunction;
}(autograd_1.AutoFunction));
exports.RoundFunction = RoundFunction;
var RsqrtFunction = /** @class */ (function (_super) {
    __extends(RsqrtFunction, _super);
    function RsqrtFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RsqrtFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("rsqrt", { "dtype": "float32" }, params, [input.shape])[0];
    };
    RsqrtFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    RsqrtFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("rsqrtGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return RsqrtFunction;
}(autograd_1.AutoFunction));
exports.RsqrtFunction = RsqrtFunction;
var SigmoidFunction = /** @class */ (function (_super) {
    __extends(SigmoidFunction, _super);
    function SigmoidFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SigmoidFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sigmoid", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SigmoidFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SigmoidFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("sigmoidGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SigmoidFunction;
}(autograd_1.AutoFunction));
exports.SigmoidFunction = SigmoidFunction;
var SignFunction = /** @class */ (function (_super) {
    __extends(SignFunction, _super);
    function SignFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SignFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sign", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SignFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SignFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("signGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SignFunction;
}(autograd_1.AutoFunction));
exports.SignFunction = SignFunction;
var SiluFunction = /** @class */ (function (_super) {
    __extends(SiluFunction, _super);
    function SiluFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SiluFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("silu", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SiluFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SiluFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("siluGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SiluFunction;
}(autograd_1.AutoFunction));
exports.SiluFunction = SiluFunction;
var SinFunction = /** @class */ (function (_super) {
    __extends(SinFunction, _super);
    function SinFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SinFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sin", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SinFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SinFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("sinGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SinFunction;
}(autograd_1.AutoFunction));
exports.SinFunction = SinFunction;
var SincFunction = /** @class */ (function (_super) {
    __extends(SincFunction, _super);
    function SincFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SincFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sinc", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SincFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SincFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("sincGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SincFunction;
}(autograd_1.AutoFunction));
exports.SincFunction = SincFunction;
var SinhFunction = /** @class */ (function (_super) {
    __extends(SinhFunction, _super);
    function SinhFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SinhFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sinh", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SinhFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SinhFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("sinhGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SinhFunction;
}(autograd_1.AutoFunction));
exports.SinhFunction = SinhFunction;
var SqrtFunction = /** @class */ (function (_super) {
    __extends(SqrtFunction, _super);
    function SqrtFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SqrtFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sqrt", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SqrtFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SqrtFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("sqrtGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SqrtFunction;
}(autograd_1.AutoFunction));
exports.SqrtFunction = SqrtFunction;
var SquareFunction = /** @class */ (function (_super) {
    __extends(SquareFunction, _super);
    function SquareFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SquareFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("square", { "dtype": "float32" }, params, [input.shape])[0];
    };
    SquareFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SquareFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("squareGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return SquareFunction;
}(autograd_1.AutoFunction));
exports.SquareFunction = SquareFunction;
var SubFunction = /** @class */ (function (_super) {
    __extends(SubFunction, _super);
    function SubFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SubFunction.forward = function (inputs) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: alpha || 1.0,
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("sub", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    SubFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 3), input = _a[0], other = _a[1], alpha = _a[2];
        ctx.alpha = alpha;
        ctx.saveForBackward(input, other);
    };
    SubFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
            alpha: ctx.alpha || 1.0,
        };
        return input.runKernel("subGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return SubFunction;
}(autograd_1.AutoFunction));
exports.SubFunction = SubFunction;
var TanFunction = /** @class */ (function (_super) {
    __extends(TanFunction, _super);
    function TanFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TanFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("tan", { "dtype": "float32" }, params, [input.shape])[0];
    };
    TanFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    TanFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("tanGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return TanFunction;
}(autograd_1.AutoFunction));
exports.TanFunction = TanFunction;
var TanhFunction = /** @class */ (function (_super) {
    __extends(TanhFunction, _super);
    function TanhFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TanhFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("tanh", { "dtype": "float32" }, params, [input.shape])[0];
    };
    TanhFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    TanhFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("tanhGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return TanhFunction;
}(autograd_1.AutoFunction));
exports.TanhFunction = TanhFunction;
var TruncFunction = /** @class */ (function (_super) {
    __extends(TruncFunction, _super);
    function TruncFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TruncFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("trunc", { "dtype": "float32" }, params, [input.shape])[0];
    };
    TruncFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    TruncFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("truncGrad", { "dtype": "float32" }, params, [input.shape], outputGrad);
    };
    return TruncFunction;
}(autograd_1.AutoFunction));
exports.TruncFunction = TruncFunction;
var XlogyFunction = /** @class */ (function (_super) {
    __extends(XlogyFunction, _super);
    function XlogyFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    XlogyFunction.forward = function (inputs) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        if (!other.isContiguous) {
            throw new Error("Other must be contiguous");
        }
        return input.runKernel("xlogy", { "dtype": "float32" }, params, [input.shape], other)[0];
    };
    XlogyFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 2), input = _a[0], other = _a[1];
        ctx.saveForBackward(input, other);
    };
    XlogyFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 2), input = _a[0], other = _a[1];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("xlogyGrad", { "dtype": "float32" }, params, [input.shape, other.shape], other, outputGrad);
    };
    return XlogyFunction;
}(autograd_1.AutoFunction));
exports.XlogyFunction = XlogyFunction;
var AllFunction = /** @class */ (function (_super) {
    __extends(AllFunction, _super);
    function AllFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AllFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("all", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    AllFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AllFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("allGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return AllFunction;
}(autograd_1.AutoFunction));
exports.AllFunction = AllFunction;
var AnyFunction = /** @class */ (function (_super) {
    __extends(AnyFunction, _super);
    function AnyFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnyFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("any", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    AnyFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    AnyFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("anyGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return AnyFunction;
}(autograd_1.AutoFunction));
exports.AnyFunction = AnyFunction;
var MeanFunction = /** @class */ (function (_super) {
    __extends(MeanFunction, _super);
    function MeanFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MeanFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("mean", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    MeanFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    MeanFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("meanGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return MeanFunction;
}(autograd_1.AutoFunction));
exports.MeanFunction = MeanFunction;
var NormFunction = /** @class */ (function (_super) {
    __extends(NormFunction, _super);
    function NormFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NormFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("norm", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    NormFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    NormFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("normGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return NormFunction;
}(autograd_1.AutoFunction));
exports.NormFunction = NormFunction;
var ProdFunction = /** @class */ (function (_super) {
    __extends(ProdFunction, _super);
    function ProdFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProdFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("prod", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    ProdFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    ProdFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("prodGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return ProdFunction;
}(autograd_1.AutoFunction));
exports.ProdFunction = ProdFunction;
var SumFunction = /** @class */ (function (_super) {
    __extends(SumFunction, _super);
    function SumFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SumFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("sum", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    SumFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    SumFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("sumGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return SumFunction;
}(autograd_1.AutoFunction));
exports.SumFunction = SumFunction;
var CountNonzeroFunction = /** @class */ (function (_super) {
    __extends(CountNonzeroFunction, _super);
    function CountNonzeroFunction() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CountNonzeroFunction.forward = function (inputs) {
        var _a = __read(inputs, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        if (!input.isContiguous) {
            throw new Error("Input must be contiguous");
        }
        return input.runKernel("countNonzero", { "dtype": "float32", "workgroupSize": 64 }, params, [[]])[0];
    };
    CountNonzeroFunction.setupContext = function (ctx, inputs, output) {
        var _a = __read(inputs, 1), input = _a[0];
        ctx.saveForBackward(input);
    };
    CountNonzeroFunction.backward = function (ctx, outputGrad) {
        var _a = __read(ctx.savedTensors, 1), input = _a[0];
        var params = {
            size: (0, shape_1.shapeSize)(input.shape),
        };
        return input.runKernel("countNonzeroGrad", { "dtype": "float32", "workgroupSize": 64 }, params, [input.shape], outputGrad);
    };
    return CountNonzeroFunction;
}(autograd_1.AutoFunction));
exports.CountNonzeroFunction = CountNonzeroFunction;
//# sourceMappingURL=functions_opgen.js.map