"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KernelCPU = void 0;
var kernel_1 = require("./kernel");
var KernelCPU = /** @class */ (function (_super) {
    __extends(KernelCPU, _super);
    function KernelCPU(spec, config, device) {
        var _this = _super.call(this, spec, config, device) || this;
        _this._javaScriptCode = (0, kernel_1.getKernelJavaScriptCode)(spec, config);
        _this._javaScriptFunction = eval(_this._javaScriptCode);
        return _this;
    }
    KernelCPU.prototype.run = function (inputs, parameters, outputs) {
        // console.log("run cpu kernel", this.key);
        var _this = this;
        // Build the parameter environment
        var env = this.getRunEnv(parameters);
        // Build up the args
        var args = [];
        var outputsToReturn = [];
        // Get input buffers with storage usage
        this.spec.inputs.forEach(function (input, i) {
            return args.push(_this.getStorageInputBuffer(input, inputs[i] ? inputs[i] : null, i, env));
        });
        // Get output buffers with storage usage
        this.spec.outputs.forEach(function (output, i) {
            var o = _this.getStorageOutputBuffer(output, outputs ? outputs[i] : null, i, env);
            args.push(o);
            outputsToReturn.push(o);
        });
        // Add the parameters
        args.push(parameters);
        // Finally the workgroupCount
        var _a = __read(this.getWorkgroupCounts(env), 3), workgroupCountX = _a[0], workgroupCountY = _a[1], workgroupCountZ = _a[2];
        args.push(workgroupCountX);
        args.push(workgroupCountY);
        args.push(workgroupCountZ);
        // Run the kernel
        this._javaScriptFunction.apply(null, args);
        return outputsToReturn;
    };
    KernelCPU.prototype.getStorageInputBuffer = function (inputSpec, providedInput, inputIndex, env) {
        if (providedInput === null) {
            throw new Error("Missing input buffer #".concat(inputIndex, " (out of ").concat(this.spec.inputs.length, ") named \"").concat(inputSpec.name, "\" in kernel \"").concat(this.key, "\""));
        }
        return providedInput;
    };
    KernelCPU.prototype.getStorageOutputBuffer = function (outputSpec, providedOutput, outputIndex, env) {
        if (providedOutput !== null) {
            return providedOutput;
        }
        else {
            var outputElementByteSize = (0, kernel_1.getShaderTypeElementByteSize)(outputSpec.shaderType);
            var outputElementCount = Math.ceil(this._outputSizeFuncs[outputIndex](env));
            var outputBufferSize = outputElementByteSize * outputElementCount;
            // console.log("output", outputSpec.name, "size:", outputElementCount, "* byte size:", outputElementByteSize, "= buffer size:", outputBufferSize);
            var outputBuffer = this.device.alloc(outputBufferSize);
            return outputBuffer.getTypedArray((0, kernel_1.shaderTypeToDtype)(outputSpec.shaderType));
        }
    };
    return KernelCPU;
}(kernel_1.Kernel));
exports.KernelCPU = KernelCPU;
//# sourceMappingURL=kernel_cpu.js.map