"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sequential = exports.ModuleList = exports.Container = exports.Parameter = exports.Module = void 0;
var tensor_1 = require("./tensor");
/**
 * Base class for implementing a module, which is a reusable portion of a neural network.
 * Modules can contain other modules, allowing for a tree-like structure.
 *
 * To add a submodule to a module, assign it as a property of the module in the constructor.
 * Its name will be the name of the property.
 *
 * Modules can also contain `Parameter` objects, which are tensors that are automatically
 * updated by optimizers and are saved when calling `saveDict()`.
 * To add a parameter to a module, assign it as a property of the module in the constructor.
 *
 * Module subtypes implement a `forward` function in order to define the computation of the module.
 *
 * ```
 * class Model extends torch.nn.Module {
 *     conv1: torch.nn.Conv2d;
 *     conv2: torch.nn.Conv2d;
 *     constructor() {
 *         super();
 *         this.conv1 = torch.nn.Conv2d(1, 20, 5);
 *         this.conv2 = torch.nn.Conv2d(20, 20, 5);
 *     }
 *     forward(input: torch.Tensor): torch.Tensor {
 *         let output = this.conv1.forward(input);
 *         output = output.relu();
 *         output = this.conv2.forward(output);
 *         output = output.relu();
 *         return output;
 *     }
 * }
 * ```
 */
var Module = /** @class */ (function () {
    function Module() {
        this._children = null;
        this._parameters = null;
        this._buffers = [];
        this._nonPersistentBuffersSet = new Set();
        this._training = true;
    }
    Object.defineProperty(Module.prototype, "namedChildren", {
        /**
         * Returns the immediate children (submodules) of this module along with their names.
         */
        get: function () {
            if (this._children === null) {
                this._children = [];
                for (var key in this) {
                    var value = this[key];
                    if (value instanceof Module) {
                        this._children.push([key, value]);
                    }
                }
            }
            return this._children;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "children", {
        /**
         * Returns the immediate children (submodules) of this module.
         */
        get: function () {
            return this.namedChildren.map(function (_a) {
                var _b = __read(_a, 2), _ = _b[0], value = _b[1];
                return value;
            });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "immediateParameters", {
        get: function () {
            if (this._parameters === null) {
                this._parameters = [];
                for (var key in this) {
                    var value = this[key];
                    if (value instanceof Parameter) {
                        this._parameters.push([key, value]);
                    }
                }
            }
            return this._parameters;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Module.prototype, "training", {
        get: function () {
            return this._training;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Module.prototype, Symbol.toStringTag, {
        get: function () {
            return "Module";
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Produces a multiline readable string of the module and its descendants.
     * @returns A string representation of the module and its descendants.
     */
    Module.prototype.toString = function () {
        var e_1, _a;
        var childLines = [];
        try {
            for (var _b = __values(this.namedChildren), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), name_1 = _d[0], module_1 = _d[1];
                var modLines = module_1.toString().split("\n");
                var modStr = modLines.length === 1
                    ? modLines[0]
                    : modLines[0] +
                        "\n" +
                        modLines
                            .splice(1)
                            .map(function (line) { return "  ".concat(line); })
                            .join("\n");
                childLines.push("(".concat(name_1, "): ").concat(modStr));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var lines = childLines;
        var mainStr = this.constructor.name + "(";
        if (lines.length > 0) {
            mainStr += "\n  ".concat(lines.join("\n  "), "\n");
        }
        mainStr += ")";
        return mainStr;
    };
    /**
     * Adds a child module of the current module.
     *
     * The module can be accessed as a property using the given name.
     * @param name name of the child module
     * @param module child module to be added
     */
    Module.prototype.addModule = function (name, module) {
        if (this[name] !== undefined) {
            throw new Error("Module already has a child named ".concat(name));
        }
        if (typeof name === "string" && name.indexOf(".") !== -1) {
            throw new Error("Module name cannot contain \".\"");
        }
        this[name] = module;
        this._children = null;
    };
    /**
     * Returns this module and its descendants' along with their prefixed names.
     * @param memo is a set of modules used to avoid double counting.
     * @param prefix is prependended to the names of the modules.
     * @param removeDuplicate is a boolean indicating whether to remove duplicate modules.
     * @returns a generator of [prefixed name, module] pairs.
     */
    Module.prototype.namedModules = function (memo, prefix, removeDuplicate) {
        var _a, _b, _c, name_2, module_2, submodulePrefix, e_2_1;
        var e_2, _d;
        if (prefix === void 0) { prefix = ""; }
        if (removeDuplicate === void 0) { removeDuplicate = true; }
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    memo = memo || new Set();
                    if (!!memo.has(this)) return [3 /*break*/, 9];
                    if (removeDuplicate) {
                        memo.add(this);
                    }
                    return [4 /*yield*/, [prefix, this]];
                case 1:
                    _e.sent();
                    _e.label = 2;
                case 2:
                    _e.trys.push([2, 7, 8, 9]);
                    _a = __values(this.namedChildren), _b = _a.next();
                    _e.label = 3;
                case 3:
                    if (!!_b.done) return [3 /*break*/, 6];
                    _c = __read(_b.value, 2), name_2 = _c[0], module_2 = _c[1];
                    if (!module_2) {
                        return [3 /*break*/, 5];
                    }
                    submodulePrefix = prefix ? "".concat(prefix, ".").concat(name_2) : "".concat(name_2);
                    return [5 /*yield**/, __values(module_2.namedModules(memo, submodulePrefix, removeDuplicate))];
                case 4:
                    _e.sent();
                    _e.label = 5;
                case 5:
                    _b = _a.next();
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    e_2_1 = _e.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 9];
                case 8:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/];
            }
        });
    };
    /**
     * Returns this module and its descendants.
     * @returns a generator of modules
     */
    Module.prototype.modules = function () {
        var _a, _b, _c, _, module_3, e_3_1;
        var e_3, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _e.trys.push([0, 5, 6, 7]);
                    _a = __values(this.namedModules()), _b = _a.next();
                    _e.label = 1;
                case 1:
                    if (!!_b.done) return [3 /*break*/, 4];
                    _c = __read(_b.value, 2), _ = _c[0], module_3 = _c[1];
                    return [4 /*yield*/, module_3];
                case 2:
                    _e.sent();
                    _e.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_3_1 = _e.sent();
                    e_3 = { error: e_3_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    Module.prototype._named_members = function (get_members_fn, prefix, recurse, remove_duplicate) {
        var memo, modules, modules_1, modules_1_1, _a, module_prefix, module, members, members_1, members_1_1, _b, k, v, name_3, e_4_1, e_5_1;
        var e_5, _c, e_4, _d;
        if (prefix === void 0) { prefix = ""; }
        if (recurse === void 0) { recurse = true; }
        if (remove_duplicate === void 0) { remove_duplicate = true; }
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    memo = new Set();
                    modules = recurse
                        ? this.namedModules(undefined, prefix, remove_duplicate)
                        : [[prefix, this]];
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 12, 13, 14]);
                    modules_1 = __values(modules), modules_1_1 = modules_1.next();
                    _e.label = 2;
                case 2:
                    if (!!modules_1_1.done) return [3 /*break*/, 11];
                    _a = __read(modules_1_1.value, 2), module_prefix = _a[0], module = _a[1];
                    members = get_members_fn(module);
                    _e.label = 3;
                case 3:
                    _e.trys.push([3, 8, 9, 10]);
                    members_1 = (e_4 = void 0, __values(members)), members_1_1 = members_1.next();
                    _e.label = 4;
                case 4:
                    if (!!members_1_1.done) return [3 /*break*/, 7];
                    _b = __read(members_1_1.value, 2), k = _b[0], v = _b[1];
                    if (v == null || memo.has(v))
                        return [3 /*break*/, 6];
                    if (remove_duplicate)
                        memo.add(v);
                    name_3 = module_prefix ? "".concat(module_prefix, ".").concat(k) : k;
                    return [4 /*yield*/, [name_3, v]];
                case 5:
                    _e.sent();
                    _e.label = 6;
                case 6:
                    members_1_1 = members_1.next();
                    return [3 /*break*/, 4];
                case 7: return [3 /*break*/, 10];
                case 8:
                    e_4_1 = _e.sent();
                    e_4 = { error: e_4_1 };
                    return [3 /*break*/, 10];
                case 9:
                    try {
                        if (members_1_1 && !members_1_1.done && (_d = members_1.return)) _d.call(members_1);
                    }
                    finally { if (e_4) throw e_4.error; }
                    return [7 /*endfinally*/];
                case 10:
                    modules_1_1 = modules_1.next();
                    return [3 /*break*/, 2];
                case 11: return [3 /*break*/, 14];
                case 12:
                    e_5_1 = _e.sent();
                    e_5 = { error: e_5_1 };
                    return [3 /*break*/, 14];
                case 13:
                    try {
                        if (modules_1_1 && !modules_1_1.done && (_c = modules_1.return)) _c.call(modules_1);
                    }
                    finally { if (e_5) throw e_5.error; }
                    return [7 /*endfinally*/];
                case 14: return [2 /*return*/];
            }
        });
    };
    /**
     * Gets this module and its descendants' (if `recurse = true`) parameters along with their prefixed names.
     * @param prefix is prependended to the names of the parameters
     * @param recurse whether to include submodule parameters
     * @param removeDuplicate whether to remove duplicate parameters
     * @returns a generator of [prefixed name, parameter] pairs
     */
    Module.prototype.namedParameters = function (prefix, recurse, removeDuplicate) {
        if (prefix === void 0) { prefix = ""; }
        if (recurse === void 0) { recurse = true; }
        if (removeDuplicate === void 0) { removeDuplicate = true; }
        return this._named_members(function (m) { return m.immediateParameters; }, prefix, recurse, removeDuplicate);
    };
    Module.prototype.parameters = function () {
        var _a, _b, _c, _, parameter, e_6_1;
        var e_6, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _e.trys.push([0, 5, 6, 7]);
                    _a = __values(this.namedParameters()), _b = _a.next();
                    _e.label = 1;
                case 1:
                    if (!!_b.done) return [3 /*break*/, 4];
                    _c = __read(_b.value, 2), _ = _c[0], parameter = _c[1];
                    return [4 /*yield*/, parameter];
                case 2:
                    _e.sent();
                    _e.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_6_1 = _e.sent();
                    e_6 = { error: e_6_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_6) throw e_6.error; }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    Module.prototype.registerBuffer = function (name, tensor, persistent) {
        if (persistent === void 0) { persistent = true; }
        if (!name) {
            throw new Error("Buffer name must not be empty.");
        }
        if (name.indexOf(".") !== -1) {
            throw new Error("Buffer name must not contain a period.");
        }
        if (this._buffers.some(function (_a) {
            var _b = __read(_a, 2), n = _b[0], _ = _b[1];
            return n === name;
        })) {
            throw new Error("Buffer ".concat(name, " already registered."));
        }
        this._buffers.push([name, tensor]);
        if (persistent) {
            this._nonPersistentBuffersSet.delete(name);
        }
        else {
            this._nonPersistentBuffersSet.add(name);
        }
    };
    Module.prototype.namedBuffers = function (prefix, recurse, removeDuplicate) {
        if (prefix === void 0) { prefix = ""; }
        if (recurse === void 0) { recurse = true; }
        if (removeDuplicate === void 0) { removeDuplicate = true; }
        return this._named_members(function (m) { return m._buffers; }, prefix, recurse, removeDuplicate);
    };
    Module.prototype.buffers = function () {
        var _a, _b, _c, _, buffer, e_7_1;
        var e_7, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    _e.trys.push([0, 5, 6, 7]);
                    _a = __values(this.namedBuffers()), _b = _a.next();
                    _e.label = 1;
                case 1:
                    if (!!_b.done) return [3 /*break*/, 4];
                    _c = __read(_b.value, 2), _ = _c[0], buffer = _c[1];
                    return [4 /*yield*/, buffer];
                case 2:
                    _e.sent();
                    _e.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_7_1 = _e.sent();
                    e_7 = { error: e_7_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_d = _a.return)) _d.call(_a);
                    }
                    finally { if (e_7) throw e_7.error; }
                    return [7 /*endfinally*/];
                case 7: return [2 /*return*/];
            }
        });
    };
    /**
     * Sets the module in training mode.
     * @param mode whether to set training mode (`true`) or evaluation mode (`false`).
     * @returns this module
     */
    Module.prototype.train = function (mode) {
        var e_8, _a;
        if (mode === void 0) { mode = true; }
        this._training = mode;
        try {
            for (var _b = __values(this.children), _c = _b.next(); !_c.done; _c = _b.next()) {
                var module_4 = _c.value;
                module_4.train(mode);
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_8) throw e_8.error; }
        }
        return this;
    };
    /**
     * Sets the module in evaluation mode.
     * @returns this module
     */
    Module.prototype.eval = function () {
        return this.train(false);
    };
    /**
     * Change if autograd should record operations on parameters in this module.
     * @param requiresGrad whether to enable gradient calculation for parameters in this module.
     * @returns this module
     */
    Module.prototype.requiresGrad = function (requiresGrad) {
        var e_9, _a;
        if (requiresGrad === void 0) { requiresGrad = true; }
        try {
            for (var _b = __values(this.parameters()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var parameter = _c.value;
                parameter.requiresGrad = requiresGrad;
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_9) throw e_9.error; }
        }
        return this;
    };
    /**
     * Zeros out the gradients of all parameters. That can be accomplished either by
     * setting the `grad` property to `null` (`setToNull=true`) or
     * by filling the gradient tensor with zeros (`setToNull=false`).
     * @param setToNull whether to set gradients to `null` (`true`) or to zero tensors (`false`).
     * @returns this module
     */
    Module.prototype.zeroGrad = function (setToNull) {
        var e_10, _a;
        if (setToNull === void 0) { setToNull = true; }
        try {
            for (var _b = __values(this.parameters()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var parameter = _c.value;
                if (parameter.grad) {
                    if (setToNull) {
                        parameter.grad = null;
                    }
                    else {
                        if (parameter.grad.gradFunc) {
                            parameter.grad.detach();
                        }
                        else {
                            parameter.grad.requiresGrad = false;
                        }
                        parameter.grad.zero_();
                        throw new Error("Not implemented: Cannot set gradients to 0. Use setToNull=true instead.");
                    }
                }
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_10) throw e_10.error; }
        }
        return this;
    };
    /**
     * Returns the state dictionary of the module and its descendants.
     * @param destination An optional state dictionary to update with the module's state.
     * @param prefix A string to prepend to the names of the state entries (default is an empty string).
     * @param keepVars A boolean flag, if true keeps the tensors attached to autograd (default is true).
     * @returns The updated state dictionary containing the module's state.
     */
    Module.prototype.stateDict = function (destination, prefix, keepVars) {
        var e_11, _a;
        if (prefix === void 0) { prefix = ""; }
        if (keepVars === void 0) { keepVars = true; }
        destination = destination || {};
        this._saveToStateDict(destination, prefix, keepVars);
        try {
            for (var _b = __values(this.namedChildren), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), name_4 = _d[0], module_5 = _d[1];
                if (module_5) {
                    module_5.stateDict(destination, prefix + name_4 + ".", keepVars);
                }
            }
        }
        catch (e_11_1) { e_11 = { error: e_11_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_11) throw e_11.error; }
        }
        return destination;
    };
    Module.prototype._saveToStateDict = function (destination, prefix, keepVars) {
        var e_12, _a, e_13, _b;
        try {
            for (var _c = __values(this.namedParameters()), _d = _c.next(); !_d.done; _d = _c.next()) {
                var _e = __read(_d.value, 2), name_5 = _e[0], parameter = _e[1];
                if (parameter) {
                    destination[prefix + name_5] = keepVars
                        ? parameter
                        : parameter.detach();
                }
            }
        }
        catch (e_12_1) { e_12 = { error: e_12_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_12) throw e_12.error; }
        }
        try {
            for (var _f = __values(this.namedBuffers()), _g = _f.next(); !_g.done; _g = _f.next()) {
                var _h = __read(_g.value, 2), name_6 = _h[0], buffer = _h[1];
                if (buffer && !this._nonPersistentBuffersSet.has(name_6)) {
                    destination[prefix + name_6] = keepVars
                        ? buffer
                        : buffer.detach();
                }
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
            }
            finally { if (e_13) throw e_13.error; }
        }
    };
    /**
     * Loads the state of the module and its descendants from the given state dictionary.
     * @param stateDict The state dictionary containing the state of the module to load.
     */
    Module.prototype.loadStateDict = function (stateDict) {
        function load(module, localStateDict, prefix) {
            var e_14, _a, e_15, _b;
            module._loadFromStateDict(localStateDict, prefix);
            try {
                for (var _c = __values(module.namedChildren), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var _e = __read(_d.value, 2), name_7 = _e[0], child = _e[1];
                    if (child) {
                        var childPrefix = prefix + name_7 + ".";
                        var childStateDict = {};
                        try {
                            for (var _f = (e_15 = void 0, __values(Object.entries(localStateDict))), _g = _f.next(); !_g.done; _g = _f.next()) {
                                var _h = __read(_g.value, 2), k = _h[0], v = _h[1];
                                if (k.startsWith(childPrefix)) {
                                    childStateDict[k] = v;
                                }
                            }
                        }
                        catch (e_15_1) { e_15 = { error: e_15_1 }; }
                        finally {
                            try {
                                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                            }
                            finally { if (e_15) throw e_15.error; }
                        }
                        load(child, childStateDict, childPrefix);
                    }
                }
            }
            catch (e_14_1) { e_14 = { error: e_14_1 }; }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                }
                finally { if (e_14) throw e_14.error; }
            }
        }
        load(this, stateDict, "");
    };
    Module.prototype._loadFromStateDict = function (stateDict, prefix) {
        throw new Error("State dict loading not implemented");
    };
    return Module;
}());
exports.Module = Module;
var Parameter = /** @class */ (function (_super) {
    __extends(Parameter, _super);
    function Parameter(data, requiresGrad) {
        if (requiresGrad === void 0) { requiresGrad = true; }
        data = data; // || empty(0);
        return _super.call(this, {
            data: data.storage,
            dtype: data.dtype,
            shape: data.shape,
            strides: data.strides,
            requiresGrad: requiresGrad,
            device: data.device,
        }) || this;
    }
    return Parameter;
}(tensor_1.Tensor));
exports.Parameter = Parameter;
/**
 * An abstraction for modules that accept child modules as arguments.
 */
var Container = /** @class */ (function (_super) {
    __extends(Container, _super);
    function Container() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Container;
}(Module));
exports.Container = Container;
/**
 * Hold submodules in a list.
 */
var ModuleList = /** @class */ (function (_super) {
    __extends(ModuleList, _super);
    function ModuleList(modules) {
        var e_16, _a;
        if (modules === void 0) { modules = []; }
        var _this = _super.call(this) || this;
        try {
            for (var _b = __values(modules.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), i = _d[0], module_6 = _d[1];
                _this.addModule(i, module_6);
            }
        }
        catch (e_16_1) { e_16 = { error: e_16_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_16) throw e_16.error; }
        }
        return _this;
    }
    Object.defineProperty(ModuleList.prototype, "length", {
        get: function () {
            return this.children.length;
        },
        enumerable: false,
        configurable: true
    });
    ModuleList.prototype[Symbol.iterator] = function () {
        return this.children[Symbol.iterator]();
    };
    ModuleList.prototype.push = function (module) {
        this.addModule(this.children.length, module);
    };
    return ModuleList;
}(Module));
exports.ModuleList = ModuleList;
/**
 * A sequential container.
 *
 * Modules will be added to it in the order they are passed in the constructor.
 *
 * The `forward()` method of Sequential accepts any input and forwards it to the first module.
 * It then forwards the output of that module to the second module, and so on,
 * finally returning the output of the last module.
 */
var Sequential = /** @class */ (function (_super) {
    __extends(Sequential, _super);
    function Sequential(modules) {
        var e_17, _a;
        var _this = _super.call(this) || this;
        try {
            for (var _b = __values(modules.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var _d = __read(_c.value, 2), i = _d[0], module_7 = _d[1];
                _this.addModule(i, module_7);
            }
        }
        catch (e_17_1) { e_17 = { error: e_17_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_17) throw e_17.error; }
        }
        return _this;
    }
    Object.defineProperty(Sequential.prototype, "length", {
        get: function () {
            return this.children.length;
        },
        enumerable: false,
        configurable: true
    });
    Sequential.prototype[Symbol.iterator] = function () {
        return this.children[Symbol.iterator]();
    };
    Sequential.prototype.forward = function (input) {
        var e_18, _a;
        try {
            for (var _b = __values(this.children), _c = _b.next(); !_c.done; _c = _b.next()) {
                var module_8 = _c.value;
                input = module_8.forward(input);
            }
        }
        catch (e_18_1) { e_18 = { error: e_18_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_18) throw e_18.error; }
        }
        return input;
    };
    return Sequential;
}(Container));
exports.Sequential = Sequential;
//# sourceMappingURL=nn_module.js.map