"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiLU = exports.ReLU = void 0;
var nn_module_1 = require("./nn_module");
/**
* ![Plot of relu and its gradient](/plots/relu.svg)
*
* Calculates:
* ```js
* output = max(input, 0.0)
* ```
*
* Gradient:
* ```js
* inputGrad = input > 0.0 ? outputGrad : 0.0
* ```
*
*/
var ReLU = /** @class */ (function (_super) {
    __extends(ReLU, _super);
    function ReLU() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ReLU.prototype.forward = function (input) {
        return input.relu();
    };
    return ReLU;
}(nn_module_1.Module));
exports.ReLU = ReLU;
/**
* ![Plot of silu and its gradient](/plots/silu.svg)
*
* Calculates:
* ```js
* output = input / (1.0 + exp(-input))
* ```
*
* Gradient:
* ```js
* var out = 1.0 / (1.0 + exp(-input)); inputGrad = outputGrad * (out + input * out * (1.0 - out))
* ```
*
*/
var SiLU = /** @class */ (function (_super) {
    __extends(SiLU, _super);
    function SiLU() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SiLU.prototype.forward = function (input) {
        return input.silu();
    };
    return SiLU;
}(nn_module_1.Module));
exports.SiLU = SiLU;
//# sourceMappingURL=nn_opgen.js.map