"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.newTypedArrayFromArray = exports.newTypedArrayForDtype = exports.GPUBufferStorage = exports.ArrayBufferStorage = exports.UntypedStorage = void 0;
var dtype_1 = require("./dtype");
var shape_1 = require("./shape");
var UntypedStorage = /** @class */ (function () {
    function UntypedStorage() {
    }
    UntypedStorage.prototype.getTypedArray = function (dtype) {
        var buffer = this.mappedArrayBuffer;
        if (buffer === null) {
            throw new Error("Storage is not mapped");
        }
        if (dtype in dtype_1.dtypeArrayCtors) {
            return new dtype_1.dtypeArrayCtors[dtype](buffer);
        }
        throw new Error("Unsupported dtype: ".concat(dtype));
    };
    return UntypedStorage;
}());
exports.UntypedStorage = UntypedStorage;
var ArrayBufferStorage = /** @class */ (function (_super) {
    __extends(ArrayBufferStorage, _super);
    function ArrayBufferStorage(byteSize) {
        var _this = _super.call(this) || this;
        if (typeof byteSize === "number") {
            _this._buffer = new ArrayBuffer(byteSize);
        }
        else if (byteSize instanceof ArrayBuffer) {
            _this._buffer = byteSize;
        }
        else if (byteSize instanceof Uint8Array) {
            _this._buffer = byteSize.buffer;
        }
        else if (byteSize instanceof Int32Array) {
            _this._buffer = byteSize.buffer;
        }
        else if (byteSize instanceof Float32Array) {
            _this._buffer = byteSize.buffer;
        }
        else {
            throw new Error("Invalid constructor argument for ArrayBufferStorage. Expected number of bytes, ArrayBuffer, or a TypedArray. Got ".concat(byteSize, " (").concat(byteSize.constructor.name, ")"));
        }
        return _this;
    }
    Object.defineProperty(ArrayBufferStorage.prototype, "cpuBuffer", {
        get: function () {
            return this._buffer;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ArrayBufferStorage.prototype, "byteSize", {
        get: function () {
            return this._buffer.byteLength;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ArrayBufferStorage.prototype, "mappedArrayBuffer", {
        get: function () {
            return this._buffer;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ArrayBufferStorage.prototype, "isMapped", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    ArrayBufferStorage.prototype.mapReadAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    ArrayBufferStorage.prototype.unmap = function () {
        // Do nothing
    };
    ArrayBufferStorage.prototype.destroy = function () {
        // Do nothing
    };
    return ArrayBufferStorage;
}(UntypedStorage));
exports.ArrayBufferStorage = ArrayBufferStorage;
var GPUBufferStorage = /** @class */ (function (_super) {
    __extends(GPUBufferStorage, _super);
    function GPUBufferStorage(input, device, usage) {
        var _this = _super.call(this) || this;
        _this._mappedArrayBuffer = null;
        _this._device = device;
        if (input instanceof GPUBuffer) {
            _this._buffer = input;
            switch (_this._buffer.mapState) {
                case "mapped":
                    _this._mappedArrayBuffer = [_this._buffer, null];
                    break;
                case "unmapped":
                    _this._mappedArrayBuffer = null;
                    break;
                case "pending":
                    throw new Error("GPUBuffer is pending. Please wait for it to finish mapping before creating a GPUBufferStorage with it.");
            }
        }
        else if (typeof input === "number" && usage !== undefined && device !== undefined) {
            _this._buffer = device.createBuffer({
                mappedAtCreation: true,
                size: input,
                usage: usage,
            });
            _this._mappedArrayBuffer = [_this._buffer, null];
        }
        else {
            throw new Error("Invalid constructor arguments for GPUBufferStorage. Expected GPUBuffer, or byteSize, usage, and device. Got ".concat(input, " (").concat(input.constructor.name, ")"));
        }
        return _this;
    }
    Object.defineProperty(GPUBufferStorage.prototype, "byteSize", {
        get: function () {
            return this._buffer.size;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GPUBufferStorage.prototype, "gpuBuffer", {
        get: function () {
            return this._buffer;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GPUBufferStorage.prototype, "gpuDevice", {
        get: function () {
            return this._device;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GPUBufferStorage.prototype, "mappedArrayBuffer", {
        get: function () {
            if (this._mappedArrayBuffer !== null) {
                var ar = this._mappedArrayBuffer[1];
                if (ar === null) {
                    ar = this._mappedArrayBuffer[0].getMappedRange();
                    this._mappedArrayBuffer[1] = ar;
                }
                return ar;
            }
            return null;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GPUBufferStorage.prototype, "isMapped", {
        get: function () {
            return this._buffer.mapState === "mapped";
        },
        enumerable: false,
        configurable: true
    });
    GPUBufferStorage.prototype.mapReadAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var mapBuffer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isMapped) {
                            return [2 /*return*/];
                        }
                        mapBuffer = this._buffer;
                        if ((this._buffer.usage & GPUBufferUsage.MAP_READ) === 0) {
                            mapBuffer = this.copyBufferToReadableBuffer();
                        }
                        return [4 /*yield*/, mapBuffer.mapAsync(GPUMapMode.READ)];
                    case 1:
                        _a.sent();
                        if (mapBuffer.mapState === "mapped") {
                            this._mappedArrayBuffer = [mapBuffer, null];
                        }
                        else {
                            throw new Error("GPUBuffer failed to map");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    GPUBufferStorage.prototype.unmap = function () {
        this._mappedArrayBuffer = null;
        this._buffer.unmap();
    };
    GPUBufferStorage.prototype.destroy = function () {
        this._mappedArrayBuffer = null;
        this._buffer.destroy();
    };
    GPUBufferStorage.prototype.copyBufferToReadableBuffer = function () {
        var size = this._buffer.size;
        var readBuffer = this._device.createBuffer({
            mappedAtCreation: false,
            size: size,
            usage: GPUBufferUsage.COPY_DST | GPUBufferUsage.MAP_READ,
        });
        // console.log("copyBufferToReadableBuffer", this._buffer, readBuffer);
        // Encode commands for copying outputs to readable buffers
        var commandEncoder = this._device.createCommandEncoder();
        commandEncoder.copyBufferToBuffer(this._buffer /* source buffer */, 0 /* source offset */, readBuffer /* destination buffer */, 0 /* destination offset */, size /* size */);
        // Submit GPU commands
        var gpuCommands = commandEncoder.finish();
        this._device.queue.submit([gpuCommands]);
        return readBuffer;
    };
    return GPUBufferStorage;
}(UntypedStorage));
exports.GPUBufferStorage = GPUBufferStorage;
function newTypedArrayForDtype(length, dtype) {
    switch (dtype) {
        case "uint8":
            return new Uint8Array(length);
        case "int32":
            return new Int32Array(length);
        case "float32":
            return new Float32Array(length);
        default:
            throw new Error("Unsupported dtype: ".concat(dtype));
    }
}
exports.newTypedArrayForDtype = newTypedArrayForDtype;
function newTypedArrayFromArray(data, dtype, device) {
    var shape = [];
    function getShape(data) {
        if (typeof data === "number") {
            return;
        }
        shape.push(data.length);
        getShape(data[0]);
    }
    if (data !== null) {
        getShape(data);
    }
    var strides = (0, shape_1.defaultStrides)(shape);
    var size = (0, shape_1.shapeSize)(shape);
    var storage = device.allocFor(shape, dtype);
    var flatData = storage.getTypedArray(dtype);
    var flatIndex = 0;
    function flatten(data) {
        for (var i = 0; i < data.length; i++) {
            var d = data[i];
            if (typeof d === "number") {
                for (var j = 0; j < data.length; j++) {
                    flatData[flatIndex] = data[j];
                    flatIndex++;
                }
                return;
            }
            if (d instanceof Array) {
                flatten(d);
            }
            else {
                throw new Error("Invalid data type: ".concat(d, " (").concat(d.constructor.name, ")"));
            }
        }
    }
    if (data !== null) {
        flatten(data);
    }
    return { storage: storage, shape: shape, strides: strides };
}
exports.newTypedArrayFromArray = newTypedArrayFromArray;
//# sourceMappingURL=storage.js.map