"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tensor = void 0;
var devices_1 = require("./devices");
var shape_1 = require("./shape");
var factories_1 = require("./factories");
var dtype_1 = require("./dtype");
var storage_1 = require("./storage");
var ops = require("./ops_opgen");
var aops = require("./ops_artisanal");
var tensor_base_1 = require("./tensor_base");
var Tensor = /** @class */ (function (_super) {
    __extends(Tensor, _super);
    function Tensor(arrayOrSpec, dtype, device, requiresGrad) {
        var _this = _super.call(this) || this;
        _this._requiresGrad = false;
        _this.grad = null;
        var d = (0, devices_1.getDevice)(device);
        var dt = (0, dtype_1.getDtype)(dtype);
        if (arrayOrSpec === null) {
            throw new Error("Cannot create tensor from null");
        }
        else if (arrayOrSpec instanceof Array) {
            var array = (0, storage_1.newTypedArrayFromArray)(arrayOrSpec, dt, d);
            _this._storage = array.storage;
            _this._dtype = dt;
            _this._shape = array.shape;
            _this._strides = array.strides;
        }
        else if (arrayOrSpec.hasOwnProperty("data")) {
            var jdata = arrayOrSpec;
            dt = jdata.dtype ? (0, dtype_1.getDtype)(jdata.dtype) : dt;
            requiresGrad = requiresGrad || jdata.requiresGrad;
            if (jdata.data instanceof Array) {
                var array = (0, storage_1.newTypedArrayFromArray)(jdata.data, dt, d);
                _this._storage = array.storage;
                _this._dtype = dt;
                _this._shape = array.shape;
                _this._strides = array.strides;
            }
            else if (jdata.data instanceof storage_1.UntypedStorage) {
                _this._storage = jdata.data;
                _this._dtype = dt;
                if (jdata.shape === undefined && jdata.strides === undefined) {
                    throw new Error("Cannot create tensor from storage without also specifying the shape and strides.");
                }
                _this._shape = jdata.shape || [];
                _this._strides = jdata.strides || (0, shape_1.defaultStrides)(_this._shape);
            }
            else {
                throw new Error("Cannot create tensor from json data " + jdata);
            }
        }
        else {
            throw new Error("Invalid data type for Tensor constructor. Expected an array of values or a json object with a 'data' property.");
        }
        _this._device = d;
        _this._requiresGrad = requiresGrad || false;
        _this._gradFunc = null;
        _this._gradCtx = null;
        _this.grad = null;
        return _this;
    }
    Object.defineProperty(Tensor.prototype, "storage", {
        get: function () {
            return this._storage;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "dtype", {
        get: function () {
            return this._dtype;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "shape", {
        get: function () {
            return this._shape;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "strides", {
        get: function () {
            return this._strides;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "device", {
        get: function () {
            return this._device;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "isContiguous", {
        get: function () {
            var strides = this.strides;
            var shape = this.shape;
            var offset = 1;
            for (var i = shape.length - 1; i >= 0; i--) {
                if (strides[i] !== offset) {
                    return false;
                }
                offset *= shape[i];
            }
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "isScalar", {
        get: function () {
            return (this.shape.length === 0 ||
                (this.shape.length === 1 && this.shape[0] === 1));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "requiresGrad", {
        get: function () {
            return this._requiresGrad;
        },
        set: function (value) {
            if (this._gradFunc) {
                throw new Error("You can only change requiresGrad flags of leaf variables. If you want to use a computed variable in a subgraph that doesn't require differentiation use valueNoGrad = value.detach().");
            }
            this._requiresGrad = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tensor.prototype, "gradFunc", {
        get: function () {
            return this._gradFunc;
        },
        enumerable: false,
        configurable: true
    });
    Tensor.prototype.withShape = function (shape, strides) {
        if ((0, shape_1.shapeSize)(shape) != (0, shape_1.shapeSize)(this.shape)) {
            throw new Error("Cannot reshape tensor of size ".concat(this.shape, " to ").concat(shape));
        }
        return new Tensor({
            data: this.storage,
            dtype: this.dtype,
            device: this.device,
            requiresGrad: this.requiresGrad,
            shape: shape,
            strides: strides,
        });
    };
    Object.defineProperty(Tensor.prototype, Symbol.toStringTag, {
        get: function () {
            return "Tensor";
        },
        enumerable: false,
        configurable: true
    });
    Tensor.prototype.toString = function () {
        var rg = this.requiresGrad ? ", requiresGrad=true" : "";
        if (this._gradFunc) {
            rg = ", gradFunc";
        }
        return "tensor([".concat(this.shape, "], ").concat(this.dtype).concat(rg, ")");
    };
    Tensor.prototype.toArrayAsync = function () {
        return __awaiter(this, void 0, void 0, function () {
            function readArray(index) {
                var dim = index.length;
                // console.log("Read array: ", index, "dim=", dim);
                if (dim == shape.length - 1) {
                    var offset = index.reduce(function (acc, cur, i) { return acc + cur * strides[i]; }, 0);
                    // console.log("offset=", offset);
                    var length_1 = shape[dim];
                    // console.log("length=", length);
                    var subarray = data.subarray(offset, offset + length_1);
                    // console.log("subarray=", subarray);
                    var ar = Array.from(subarray);
                    // console.log("ar=", ar);
                    return ar;
                }
                else {
                    var result = [];
                    for (var i = 0; i < shape[dim]; i++) {
                        index.push(i);
                        result.push(readArray(index));
                        index.pop();
                    }
                    return result;
                }
            }
            var data, shape, strides, index;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.storage.mapReadAsync()];
                    case 1:
                        _a.sent();
                        data = this.storage.getTypedArray(this.dtype);
                        shape = this.shape;
                        strides = this.strides;
                        if (shape.length == 0 || (shape.length == 1 && shape[0] == 1)) {
                            return [2 /*return*/, [data[0]]];
                        }
                        index = [];
                        return [2 /*return*/, readArray(index)];
                }
            });
        });
    };
    Tensor.prototype.runKernelInplace = function (name, config, params) {
        var additionalInputs = [];
        for (var _i = 3; _i < arguments.length; _i++) {
            additionalInputs[_i - 3] = arguments[_i];
        }
        if (this.requiresGrad) {
            throw new Error("A tensor that requires a gradient cannot be used in an in-place operation");
        }
        var d = this.device;
        var kernel = this.device.getKernel(name, config);
        var inputBuffers = additionalInputs.map(function (t) {
            return d.getBufferForKernel(t.storage, t.dtype);
        });
        var outputBuffers = [d.getBufferForKernel(this.storage, this.dtype)];
        kernel.run(inputBuffers, params, outputBuffers);
        return this;
    };
    Tensor.prototype.runKernel = function (name, config, params, outputShapes) {
        var _this = this;
        var additionalInputs = [];
        for (var _i = 4; _i < arguments.length; _i++) {
            additionalInputs[_i - 4] = arguments[_i];
        }
        var d = this.device;
        var kernel = d.getKernel(name, config);
        var inputBuffers = __spreadArray([
            d.getBufferForKernel(this.storage, this.dtype)
        ], __read(additionalInputs.map(function (t) {
            return d.getBufferForKernel(t.storage, t.dtype);
        })), false);
        var outputBuffers = kernel.run(inputBuffers, params);
        if (outputBuffers.length !== outputShapes.length) {
            throw new Error("Expected ".concat(outputShapes.length, " output buffers (given the provided outputShapes to runKernel), but got ").concat(outputBuffers.length, " output buffers when running the kernel \"").concat(name, "\"."));
        }
        return outputBuffers.map(function (outputBuffer, i) {
            return new Tensor({
                data: _this.device.getStorageFromKernel(outputBuffer),
                dtype: _this.dtype,
                shape: outputShapes[i],
                strides: (0, shape_1.defaultStrides)(outputShapes[i]),
                device: _this.device,
            });
        });
    };
    Tensor.prototype.detach = function () {
        if (this._requiresGrad || this._gradFunc) {
            return new Tensor({
                data: this.storage,
                dtype: this.dtype,
                requiresGrad: false,
                shape: this.shape,
                strides: this.strides,
                device: this.device,
            });
        }
        return this;
    };
    Tensor.prototype.setGradientFunction = function (ctx, gradFunc) {
        this._gradFunc = gradFunc;
        this._gradCtx = ctx;
        this._requiresGrad = true;
    };
    Tensor.prototype.backward = function (gradient) {
        if (!this.requiresGrad) {
            throw new Error("Cannot call backward on a tensor that does not require gradients");
        }
        var grad;
        if (gradient) {
            grad = gradient;
        }
        else {
            if (!this.isScalar) {
                throw new Error("Gradient can only be implicitly created for scalar outputs");
            }
            grad = (0, factories_1.ones)(1);
        }
        if (this.grad) {
            this.grad.add_(grad);
        }
        else {
            this.grad = grad;
        }
        if (!this._gradFunc || !this._gradCtx) {
            return;
        }
        var grads = this._gradFunc(this._gradCtx, grad);
        var inputs = this._gradCtx.inputsWithGradient;
        for (var i = 0; i < inputs.length; i++) {
            var input = inputs[i];
            if (input === null) {
                continue;
            }
            var grad_1 = grads[i];
            if (grad_1) {
                input.backward(grad_1);
            }
            else {
                throw new Error("Gradient function did not return a gradient for input #".concat(i, " (out of ").concat(inputs.length, "). ").concat(grads.length, " gradients were returned."));
            }
        }
    };
    Tensor.prototype.expand = function (shape) {
        var newShape = shape.slice();
        var newStrides = Array(newShape.length).fill(0);
        // Update newStrides based on the current strides
        // so that the expansion happens
        // in the correct direction
        var j = newShape.length - 1;
        var thisShape = this.shape;
        var thisStrides = this.strides;
        for (var i = thisShape.length - 1; i >= 0; i--) {
            if (thisShape[i] === 1) {
                newStrides[j] = 0;
            }
            else {
                newStrides[j] = thisStrides[i];
                j--;
            }
            if (newShape[j] === -1) {
                newShape[j] = thisShape[i];
            }
        }
        // console.log("EXPAND", this.shape, this.strides, shape, newShape, newStrides);
        return this.withShape(newShape, newStrides);
    };
    Tensor.prototype.mm = function (other) {
        return aops.mm(this, other);
    };
    Tensor.prototype.t = function () {
        return aops.t(this);
    };
    Tensor.prototype.zero_ = function () {
        throw new Error("Tensor zero_ is not implemented");
    };
    // Codegen marker
    /**
    * ![Plot of abs and its gradient](/plots/abs.svg)
    *
    * Calculates:
    * ```js
    * output = abs(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input == 0 ? 0 : (input > 0 ? outputGrad : -outputGrad)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.abs = function () {
        return ops.abs(this);
    };
    /**
    * Alias for `abs`.
    *
    * ![Plot of abs and its gradient](/plots/abs.svg)
    *
    * Calculates:
    * ```js
    * output = abs(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input == 0 ? 0 : (input > 0 ? outputGrad : -outputGrad)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.absolute = function () {
        return ops.abs(this);
    };
    /**
    * ![Plot of abs and its gradient](/plots/abs.svg)
    *
    * Calculates:
    * ```js
    * output = abs(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input == 0 ? 0 : (input > 0 ? outputGrad : -outputGrad)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.abs_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("abs_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of acos and its gradient](/plots/acos.svg)
    *
    * Calculates:
    * ```js
    * output = acos(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / sqrt(1 - input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.acos = function () {
        return ops.acos(this);
    };
    /**
    * Alias for `acos`.
    *
    * ![Plot of acos and its gradient](/plots/acos.svg)
    *
    * Calculates:
    * ```js
    * output = acos(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / sqrt(1 - input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.arccos = function () {
        return ops.acos(this);
    };
    /**
    * ![Plot of acos and its gradient](/plots/acos.svg)
    *
    * Calculates:
    * ```js
    * output = acos(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / sqrt(1 - input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.acos_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("acos_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of acosh and its gradient](/plots/acosh.svg)
    *
    * Calculates:
    * ```js
    * output = acosh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(input * input - 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.acosh = function () {
        return ops.acosh(this);
    };
    /**
    * Alias for `acosh`.
    *
    * ![Plot of acosh and its gradient](/plots/acosh.svg)
    *
    * Calculates:
    * ```js
    * output = acosh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(input * input - 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.arccosh = function () {
        return ops.acosh(this);
    };
    /**
    * ![Plot of acosh and its gradient](/plots/acosh.svg)
    *
    * Calculates:
    * ```js
    * output = acosh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(input * input - 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.acosh_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("acosh_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = input + other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad; otherGrad = outputGrad
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.add = function (other, alpha) {
        return ops.add(this, other, alpha);
    };
    /**
    * Calculates:
    * ```js
    * output = input + other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad; otherGrad = outputGrad
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.add_ = function (other, alpha) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
            alpha: alpha || 1.0,
        };
        return this.runKernelInplace("add_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of asin and its gradient](/plots/asin.svg)
    *
    * Calculates:
    * ```js
    * output = asin(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(1 - input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.asin = function () {
        return ops.asin(this);
    };
    /**
    * Alias for `asin`.
    *
    * ![Plot of asin and its gradient](/plots/asin.svg)
    *
    * Calculates:
    * ```js
    * output = asin(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(1 - input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.arcsin = function () {
        return ops.asin(this);
    };
    /**
    * ![Plot of asin and its gradient](/plots/asin.svg)
    *
    * Calculates:
    * ```js
    * output = asin(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(1 - input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.asin_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("asin_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of asinh and its gradient](/plots/asinh.svg)
    *
    * Calculates:
    * ```js
    * output = asinh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(input * input + 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.asinh = function () {
        return ops.asinh(this);
    };
    /**
    * Alias for `asinh`.
    *
    * ![Plot of asinh and its gradient](/plots/asinh.svg)
    *
    * Calculates:
    * ```js
    * output = asinh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(input * input + 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.arcsinh = function () {
        return ops.asinh(this);
    };
    /**
    * ![Plot of asinh and its gradient](/plots/asinh.svg)
    *
    * Calculates:
    * ```js
    * output = asinh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / sqrt(input * input + 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.asinh_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("asinh_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of atan and its gradient](/plots/atan.svg)
    *
    * Calculates:
    * ```js
    * output = atan(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * input + 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.atan = function () {
        return ops.atan(this);
    };
    /**
    * Alias for `atan`.
    *
    * ![Plot of atan and its gradient](/plots/atan.svg)
    *
    * Calculates:
    * ```js
    * output = atan(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * input + 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.arctan = function () {
        return ops.atan(this);
    };
    /**
    * ![Plot of atan and its gradient](/plots/atan.svg)
    *
    * Calculates:
    * ```js
    * output = atan(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * input + 1)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.atan_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("atan_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = atan2(input, other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other / (input * input + other * other); otherGrad = -outputGrad * input / (input * input + other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.atan2 = function (other) {
        return ops.atan2(this, other);
    };
    /**
    * Alias for `atan2`.
    *
    * Calculates:
    * ```js
    * output = atan2(input, other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other / (input * input + other * other); otherGrad = -outputGrad * input / (input * input + other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.arctan2 = function (other) {
        return ops.atan2(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = atan2(input, other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other / (input * input + other * other); otherGrad = -outputGrad * input / (input * input + other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.atan2_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("atan2_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of ceil and its gradient](/plots/ceil.svg)
    *
    * Calculates:
    * ```js
    * output = ceil(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.ceil = function () {
        return ops.ceil(this);
    };
    /**
    * ![Plot of ceil and its gradient](/plots/ceil.svg)
    *
    * Calculates:
    * ```js
    * output = ceil(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.ceil_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("ceil_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = other >= 0 ? abs(input) : -abs(input)
    * ```
    *
    * Gradient:
    * ```js
    * var dir = other >= 0 ? (input >= 0 ? 1.0 : -1.0) : (input >= 0 ? -1.0 : 1.0); inputGrad = input == 0.0 ? 0.0 : outputGrad * dir; otherGrad = 0
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.copysign = function (other) {
        return ops.copysign(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = other >= 0 ? abs(input) : -abs(input)
    * ```
    *
    * Gradient:
    * ```js
    * var dir = other >= 0 ? (input >= 0 ? 1.0 : -1.0) : (input >= 0 ? -1.0 : 1.0); inputGrad = input == 0.0 ? 0.0 : outputGrad * dir; otherGrad = 0
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.copysign_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("copysign_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of cos and its gradient](/plots/cos.svg)
    *
    * Calculates:
    * ```js
    * output = cos(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad * sin(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.cos = function () {
        return ops.cos(this);
    };
    /**
    * ![Plot of cos and its gradient](/plots/cos.svg)
    *
    * Calculates:
    * ```js
    * output = cos(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad * sin(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.cos_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("cos_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of cosh and its gradient](/plots/cosh.svg)
    *
    * Calculates:
    * ```js
    * output = cosh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * sinh(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.cosh = function () {
        return ops.cosh(this);
    };
    /**
    * ![Plot of cosh and its gradient](/plots/cosh.svg)
    *
    * Calculates:
    * ```js
    * output = cosh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * sinh(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.cosh_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("cosh_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of deg2rad and its gradient](/plots/deg2rad.svg)
    *
    * Calculates:
    * ```js
    * output = input * 0.017453292519943295
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * 0.017453292519943295
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.deg2rad = function () {
        return ops.deg2rad(this);
    };
    /**
    * ![Plot of deg2rad and its gradient](/plots/deg2rad.svg)
    *
    * Calculates:
    * ```js
    * output = input * 0.017453292519943295
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * 0.017453292519943295
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.deg2rad_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("deg2rad_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = input / other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / other; otherGrad = -outputGrad * input / (other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.div = function (other, alpha) {
        return ops.div(this, other, alpha);
    };
    /**
    * Alias for `div`.
    *
    * Calculates:
    * ```js
    * output = input / other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / other; otherGrad = -outputGrad * input / (other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.divide = function (other, alpha) {
        return ops.div(this, other, alpha);
    };
    /**
    * Calculates:
    * ```js
    * output = input / other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / other; otherGrad = -outputGrad * input / (other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.div_ = function (other, alpha) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
            alpha: alpha || 1.0,
        };
        return this.runKernelInplace("div_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of exp and its gradient](/plots/exp.svg)
    *
    * Calculates:
    * ```js
    * output = exp(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * exp(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.exp = function () {
        return ops.exp(this);
    };
    /**
    * ![Plot of exp and its gradient](/plots/exp.svg)
    *
    * Calculates:
    * ```js
    * output = exp(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * exp(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.exp_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("exp_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of exp2 and its gradient](/plots/exp2.svg)
    *
    * Calculates:
    * ```js
    * output = exp2(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * exp2(input) * 0.6931471805599453
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.exp2 = function () {
        return ops.exp2(this);
    };
    /**
    * ![Plot of exp2 and its gradient](/plots/exp2.svg)
    *
    * Calculates:
    * ```js
    * output = exp2(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * exp2(input) * 0.6931471805599453
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.exp2_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("exp2_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of expm1 and its gradient](/plots/expm1.svg)
    *
    * Calculates:
    * ```js
    * output = exp(input) - 1.0
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * exp(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.expm1 = function () {
        return ops.expm1(this);
    };
    /**
    * ![Plot of expm1 and its gradient](/plots/expm1.svg)
    *
    * Calculates:
    * ```js
    * output = exp(input) - 1.0
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * exp(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.expm1_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("expm1_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of floor and its gradient](/plots/floor.svg)
    *
    * Calculates:
    * ```js
    * output = floor(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.floor = function () {
        return ops.floor(this);
    };
    /**
    * ![Plot of floor and its gradient](/plots/floor.svg)
    *
    * Calculates:
    * ```js
    * output = floor(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.floor_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("floor_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of frac and its gradient](/plots/frac.svg)
    *
    * Calculates:
    * ```js
    * output = input >= 0.0 ? fract(input) : -fract(-input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.frac = function () {
        return ops.frac(this);
    };
    /**
    * ![Plot of frac and its gradient](/plots/frac.svg)
    *
    * Calculates:
    * ```js
    * output = input >= 0.0 ? fract(input) : -fract(-input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.frac_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("frac_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = sqrt(input * input + other * other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * input / sqrt(input * input + other * other); otherGrad = outputGrad * other / sqrt(input * input + other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.hypot = function (other) {
        return ops.hypot(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = sqrt(input * input + other * other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * input / sqrt(input * input + other * other); otherGrad = outputGrad * other / sqrt(input * input + other * other)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.hypot_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("hypot_", { dtype: this.dtype }, params, other);
    };
    /**
    * Calculates:
    * ```js
    * output = input * pow(2.0, other)
    * ```
    *
    * Gradient:
    * ```js
    * var out = pow(2.0, other); inputGrad = outputGrad * out; otherGrad = outputGrad * input * out * 0.6931471805599453
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.ldexp = function (other) {
        return ops.ldexp(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = input * pow(2.0, other)
    * ```
    *
    * Gradient:
    * ```js
    * var out = pow(2.0, other); inputGrad = outputGrad * out; otherGrad = outputGrad * input * out * 0.6931471805599453
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.ldexp_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("ldexp_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of log and its gradient](/plots/log.svg)
    *
    * Calculates:
    * ```js
    * output = log(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / input
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log = function () {
        return ops.log(this);
    };
    /**
    * ![Plot of log and its gradient](/plots/log.svg)
    *
    * Calculates:
    * ```js
    * output = log(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / input
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("log_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of log10 and its gradient](/plots/log10.svg)
    *
    * Calculates:
    * ```js
    * output = log(input) * 0.4342944819032518
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * 2.302585092994046)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log10 = function () {
        return ops.log10(this);
    };
    /**
    * ![Plot of log10 and its gradient](/plots/log10.svg)
    *
    * Calculates:
    * ```js
    * output = log(input) * 0.4342944819032518
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * 2.302585092994046)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log10_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("log10_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of log1p and its gradient](/plots/log1p.svg)
    *
    * Calculates:
    * ```js
    * output = log(input + 1.0)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input + 1.0)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log1p = function () {
        return ops.log1p(this);
    };
    /**
    * ![Plot of log1p and its gradient](/plots/log1p.svg)
    *
    * Calculates:
    * ```js
    * output = log(input + 1.0)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input + 1.0)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log1p_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("log1p_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of log2 and its gradient](/plots/log2.svg)
    *
    * Calculates:
    * ```js
    * output = log2(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * 0.6931471805599453)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log2 = function () {
        return ops.log2(this);
    };
    /**
    * ![Plot of log2 and its gradient](/plots/log2.svg)
    *
    * Calculates:
    * ```js
    * output = log2(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (input * 0.6931471805599453)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.log2_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("log2_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = log(exp(input) + exp(other))
    * ```
    *
    * Gradient:
    * ```js
    * var ein = exp(input); var eoth = exp(other); var addeinv = outputGrad/(ein + eoth); inputGrad = addeinv * ein; otherGrad = addeinv * eoth
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.logaddexp = function (other) {
        return ops.logaddexp(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = log(exp(input) + exp(other))
    * ```
    *
    * Gradient:
    * ```js
    * var ein = exp(input); var eoth = exp(other); var addeinv = outputGrad/(ein + eoth); inputGrad = addeinv * ein; otherGrad = addeinv * eoth
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.logaddexp_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("logaddexp_", { dtype: this.dtype }, params, other);
    };
    /**
    * Calculates:
    * ```js
    * output = log2(exp2(input) + exp2(other))
    * ```
    *
    * Gradient:
    * ```js
    * var ein = exp2(input); var eoth = exp2(other); var sum_ein_eoth = ein + eoth; inputGrad = outputGrad * (ein / sum_ein_eoth); otherGrad = outputGrad * (eoth / sum_ein_eoth );
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.logaddexp2 = function (other) {
        return ops.logaddexp2(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = log2(exp2(input) + exp2(other))
    * ```
    *
    * Gradient:
    * ```js
    * var ein = exp2(input); var eoth = exp2(other); var sum_ein_eoth = ein + eoth; inputGrad = outputGrad * (ein / sum_ein_eoth); otherGrad = outputGrad * (eoth / sum_ein_eoth );
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.logaddexp2_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("logaddexp2_", { dtype: this.dtype }, params, other);
    };
    /**
    * Calculates:
    * ```js
    * output = input * other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other; otherGrad = outputGrad * input
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.mul = function (other, alpha) {
        return ops.mul(this, other, alpha);
    };
    /**
    * Alias for `mul`.
    *
    * Calculates:
    * ```js
    * output = input * other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other; otherGrad = outputGrad * input
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.multiply = function (other, alpha) {
        return ops.mul(this, other, alpha);
    };
    /**
    * Calculates:
    * ```js
    * output = input * other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other; otherGrad = outputGrad * input
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.mul_ = function (other, alpha) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
            alpha: alpha || 1.0,
        };
        return this.runKernelInplace("mul_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of neg and its gradient](/plots/neg.svg)
    *
    * Calculates:
    * ```js
    * output = -input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.neg = function () {
        return ops.neg(this);
    };
    /**
    * Alias for `neg`.
    *
    * ![Plot of neg and its gradient](/plots/neg.svg)
    *
    * Calculates:
    * ```js
    * output = -input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.negative = function () {
        return ops.neg(this);
    };
    /**
    * ![Plot of neg and its gradient](/plots/neg.svg)
    *
    * Calculates:
    * ```js
    * output = -input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.neg_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("neg_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of positive and its gradient](/plots/positive.svg)
    *
    * Calculates:
    * ```js
    * output = input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.positive = function () {
        return ops.positive(this);
    };
    /**
    * ![Plot of positive and its gradient](/plots/positive.svg)
    *
    * Calculates:
    * ```js
    * output = input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.positive_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("positive_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = pow(input, other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other * pow(input, other - 1.0); otherGrad = outputGrad * pow(input, other) * log(input)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.pow = function (other) {
        return ops.pow(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = pow(input, other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * other * pow(input, other - 1.0); otherGrad = outputGrad * pow(input, other) * log(input)
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.pow_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("pow_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of rad2deg and its gradient](/plots/rad2deg.svg)
    *
    * Calculates:
    * ```js
    * output = input * 57.29577951308232
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * 57.29577951308232
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.rad2deg = function () {
        return ops.rad2deg(this);
    };
    /**
    * ![Plot of rad2deg and its gradient](/plots/rad2deg.svg)
    *
    * Calculates:
    * ```js
    * output = input * 57.29577951308232
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * 57.29577951308232
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.rad2deg_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("rad2deg_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of reciprocal and its gradient](/plots/reciprocal.svg)
    *
    * Calculates:
    * ```js
    * output = 1.0 / input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / (input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.reciprocal = function () {
        return ops.reciprocal(this);
    };
    /**
    * ![Plot of reciprocal and its gradient](/plots/reciprocal.svg)
    *
    * Calculates:
    * ```js
    * output = 1.0 / input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / (input * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.reciprocal_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("reciprocal_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of relu and its gradient](/plots/relu.svg)
    *
    * Calculates:
    * ```js
    * output = max(input, 0.0)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input > 0.0 ? outputGrad : 0.0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.relu = function () {
        return ops.relu(this);
    };
    /**
    * ![Plot of relu and its gradient](/plots/relu.svg)
    *
    * Calculates:
    * ```js
    * output = max(input, 0.0)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input > 0.0 ? outputGrad : 0.0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.relu_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("relu_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of round and its gradient](/plots/round.svg)
    *
    * Calculates:
    * ```js
    * output = round(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.round = function () {
        return ops.round(this);
    };
    /**
    * ![Plot of round and its gradient](/plots/round.svg)
    *
    * Calculates:
    * ```js
    * output = round(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.round_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("round_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of rsqrt and its gradient](/plots/rsqrt.svg)
    *
    * Calculates:
    * ```js
    * output = 1.0 / sqrt(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / (2.0 * sqrt(input) * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.rsqrt = function () {
        return ops.rsqrt(this);
    };
    /**
    * ![Plot of rsqrt and its gradient](/plots/rsqrt.svg)
    *
    * Calculates:
    * ```js
    * output = 1.0 / sqrt(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = -outputGrad / (2.0 * sqrt(input) * input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.rsqrt_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("rsqrt_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of sigmoid and its gradient](/plots/sigmoid.svg)
    *
    * Calculates:
    * ```js
    * output = 1.0 / (1.0 + exp(-input))
    * ```
    *
    * Gradient:
    * ```js
    * var out = 1.0 / (1.0 + exp(-input)); inputGrad = outputGrad * out * (1.0 - out)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sigmoid = function () {
        return ops.sigmoid(this);
    };
    /**
    * ![Plot of sigmoid and its gradient](/plots/sigmoid.svg)
    *
    * Calculates:
    * ```js
    * output = 1.0 / (1.0 + exp(-input))
    * ```
    *
    * Gradient:
    * ```js
    * var out = 1.0 / (1.0 + exp(-input)); inputGrad = outputGrad * out * (1.0 - out)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sigmoid_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("sigmoid_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of sign and its gradient](/plots/sign.svg)
    *
    * Calculates:
    * ```js
    * output = sign(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sign = function () {
        return ops.sign(this);
    };
    /**
    * ![Plot of sign and its gradient](/plots/sign.svg)
    *
    * Calculates:
    * ```js
    * output = sign(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sign_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("sign_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of silu and its gradient](/plots/silu.svg)
    *
    * Calculates:
    * ```js
    * output = input / (1.0 + exp(-input))
    * ```
    *
    * Gradient:
    * ```js
    * var out = 1.0 / (1.0 + exp(-input)); inputGrad = outputGrad * (out + input * out * (1.0 - out))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.silu = function () {
        return ops.silu(this);
    };
    /**
    * ![Plot of silu and its gradient](/plots/silu.svg)
    *
    * Calculates:
    * ```js
    * output = input / (1.0 + exp(-input))
    * ```
    *
    * Gradient:
    * ```js
    * var out = 1.0 / (1.0 + exp(-input)); inputGrad = outputGrad * (out + input * out * (1.0 - out))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.silu_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("silu_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of sin and its gradient](/plots/sin.svg)
    *
    * Calculates:
    * ```js
    * output = sin(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * cos(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sin = function () {
        return ops.sin(this);
    };
    /**
    * ![Plot of sin and its gradient](/plots/sin.svg)
    *
    * Calculates:
    * ```js
    * output = sin(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * cos(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sin_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("sin_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of sinc and its gradient](/plots/sinc.svg)
    *
    * Calculates:
    * ```js
    * var inpi = input * 3.141592653589793; output = input == 0.0 ? 1.0 : sin(inpi) / inpi
    * ```
    *
    * Gradient:
    * ```js
    * var inpi = input * 3.141592653589793; inputGrad = input == 0.0 ? 0.0 : (outputGrad * 3.141592653589793 * (inpi*cos(inpi) - sin(inpi)) / (inpi*inpi))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sinc = function () {
        return ops.sinc(this);
    };
    /**
    * ![Plot of sinc and its gradient](/plots/sinc.svg)
    *
    * Calculates:
    * ```js
    * var inpi = input * 3.141592653589793; output = input == 0.0 ? 1.0 : sin(inpi) / inpi
    * ```
    *
    * Gradient:
    * ```js
    * var inpi = input * 3.141592653589793; inputGrad = input == 0.0 ? 0.0 : (outputGrad * 3.141592653589793 * (inpi*cos(inpi) - sin(inpi)) / (inpi*inpi))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sinc_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("sinc_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of sinh and its gradient](/plots/sinh.svg)
    *
    * Calculates:
    * ```js
    * output = sinh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * cosh(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sinh = function () {
        return ops.sinh(this);
    };
    /**
    * ![Plot of sinh and its gradient](/plots/sinh.svg)
    *
    * Calculates:
    * ```js
    * output = sinh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * cosh(input)
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sinh_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("sinh_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of sqrt and its gradient](/plots/sqrt.svg)
    *
    * Calculates:
    * ```js
    * output = sqrt(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (2.0 * sqrt(input))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sqrt = function () {
        return ops.sqrt(this);
    };
    /**
    * ![Plot of sqrt and its gradient](/plots/sqrt.svg)
    *
    * Calculates:
    * ```js
    * output = sqrt(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (2.0 * sqrt(input))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sqrt_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("sqrt_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of square and its gradient](/plots/square.svg)
    *
    * Calculates:
    * ```js
    * output = input * input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * 2.0 * input
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.square = function () {
        return ops.square(this);
    };
    /**
    * ![Plot of square and its gradient](/plots/square.svg)
    *
    * Calculates:
    * ```js
    * output = input * input
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * 2.0 * input
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.square_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("square_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = input - other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad; otherGrad = -outputGrad
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.sub = function (other, alpha) {
        return ops.sub(this, other, alpha);
    };
    /**
    * Alias for `sub`.
    *
    * Calculates:
    * ```js
    * output = input - other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad; otherGrad = -outputGrad
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.subtract = function (other, alpha) {
        return ops.sub(this, other, alpha);
    };
    /**
    * Calculates:
    * ```js
    * output = input - other
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad; otherGrad = -outputGrad
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @param alpha the alpha value to multiply `other` with
    * @returns the output tensor
    */
    Tensor.prototype.sub_ = function (other, alpha) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
            alpha: alpha || 1.0,
        };
        return this.runKernelInplace("sub_", { dtype: this.dtype }, params, other);
    };
    /**
    * ![Plot of tan and its gradient](/plots/tan.svg)
    *
    * Calculates:
    * ```js
    * output = tan(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (cos(input) * cos(input))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.tan = function () {
        return ops.tan(this);
    };
    /**
    * ![Plot of tan and its gradient](/plots/tan.svg)
    *
    * Calculates:
    * ```js
    * output = tan(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / (cos(input) * cos(input))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.tan_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("tan_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of tanh and its gradient](/plots/tanh.svg)
    *
    * Calculates:
    * ```js
    * output = tanh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * (1.0 - tanh(input) * tanh(input))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.tanh = function () {
        return ops.tanh(this);
    };
    /**
    * ![Plot of tanh and its gradient](/plots/tanh.svg)
    *
    * Calculates:
    * ```js
    * output = tanh(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * (1.0 - tanh(input) * tanh(input))
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.tanh_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("tanh_", { dtype: this.dtype }, params);
    };
    /**
    * ![Plot of trunc and its gradient](/plots/trunc.svg)
    *
    * Calculates:
    * ```js
    * output = trunc(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.trunc = function () {
        return ops.trunc(this);
    };
    /**
    * Alias for `trunc`.
    *
    * ![Plot of trunc and its gradient](/plots/trunc.svg)
    *
    * Calculates:
    * ```js
    * output = trunc(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.fix = function () {
        return ops.trunc(this);
    };
    /**
    * ![Plot of trunc and its gradient](/plots/trunc.svg)
    *
    * Calculates:
    * ```js
    * output = trunc(input)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = 0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.trunc_ = function () {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("trunc_", { dtype: this.dtype }, params);
    };
    /**
    * Calculates:
    * ```js
    * output = input == 0.0 ? 0.0 : input * log(other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input == 0.0 ? 0.0 : outputGrad * log(other); otherGrad = input == 0.0 ? 0.0 : outputGrad * (input / other);
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.xlogy = function (other) {
        return ops.xlogy(this, other);
    };
    /**
    * Calculates:
    * ```js
    * output = input == 0.0 ? 0.0 : input * log(other)
    * ```
    *
    * Gradient:
    * ```js
    * inputGrad = input == 0.0 ? 0.0 : outputGrad * log(other); otherGrad = input == 0.0 ? 0.0 : outputGrad * (input / other);
    * ```
    *
    * @param other the other tensor whose shape is broadcastable with the input tensor
    * @returns the output tensor
    */
    Tensor.prototype.xlogy_ = function (other) {
        var params = {
            size: (0, shape_1.shapeSize)(this.shape),
        };
        return this.runKernelInplace("xlogy_", { dtype: this.dtype }, params, other);
    };
    /**
    * Calculates:
    * ```js
    * output = output && input
    * ```
    *
    * with an initial value of `output = 1`.
    *
    * Gradient:
    * ```js
    * inputGrad = output ? outputGrad : 0.0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.all = function (dim, keepdim) {
        return ops.all(this);
    };
    /**
    * Calculates:
    * ```js
    * output = output || input
    * ```
    *
    * with an initial value of `output = 0`.
    *
    * Gradient:
    * ```js
    * inputGrad = output ? outputGrad : 0.0
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.any = function (dim, keepdim) {
        return ops.any(this);
    };
    /**
    * Calculates:
    * ```js
    * output = output + input
    * ```
    *
    * with an initial value of `output = 0.0`.
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad / inputSize
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.mean = function (dim, keepdim) {
        return ops.mean(this);
    };
    /**
    * Calculates:
    * ```js
    * output = output + input * input
    * ```
    *
    * with an initial value of `output = 0.0`.
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * input / output
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.norm = function (dim, keepdim) {
        return ops.norm(this);
    };
    /**
    * Calculates:
    * ```js
    * output = output * input
    * ```
    *
    * with an initial value of `output = 1.0`.
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad * output / input
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.prod = function (dim, keepdim) {
        return ops.prod(this);
    };
    /**
    * Calculates:
    * ```js
    * output = output + input
    * ```
    *
    * with an initial value of `output = 0.0`.
    *
    * Gradient:
    * ```js
    * inputGrad = outputGrad
    * ```
    *
    * @returns the output tensor
    */
    Tensor.prototype.sum = function (dim, keepdim) {
        return ops.sum(this);
    };
    /**
    * Calculates:
    * ```js
    * output = output + (input != 0)
    * ```
    *
    * with an initial value of `output = 0.0`.
    *
    * @returns the output tensor
    */
    Tensor.prototype.countNonzero = function (dim, keepdim) {
        return ops.countNonzero(this);
    };
    return Tensor;
}(tensor_base_1.TensorBase));
exports.Tensor = Tensor;
//# sourceMappingURL=tensor.js.map